import java.util.*;

public class TreeNode{

    String nodeId;
    String parentNodeId;
    String headId;    //for dependency tree, this is self id
    String nodeLabel; // only useful for phrase structure trees
    LinkedList<String> childrenNodeIds;
    
    public TreeNode(String id, String label, String par, String head, LinkedList<String> children)
    {
	nodeId = id;
	nodeLabel = label;
	parentNodeId = par;
	headId = head;
	childrenNodeIds = children;
    }

    public void addChild(String childid)
    {
	childrenNodeIds.add(childid);
    }

    public boolean hasChildSpecified(String childid)
    {
	if(childrenNodeIds.contains(childid))
	    return true;
	return false;
    }

    public LinkedList<String> getChildrenIds()
    {
	return childrenNodeIds;
    }
    
    public String toString()
    {
	String str = nodeId + "\t" + nodeLabel + "\t" + parentNodeId + "\t" + headId + "\t";
	String children = "";
	for(int c = 0; c < childrenNodeIds.size(); c++)
	    {
		children += childrenNodeIds.get(c);
		if(c < childrenNodeIds.size() - 1)
		    children += ",";
	    }
	if(children.trim().equals(""))
	    children = "NOCH";
	str += children.trim();
	return str.trim();
    }

    public TreeNode copy()
    {
	LinkedList<String> childCopy = new LinkedList<String>();
	childCopy.addAll(childrenNodeIds);
	return new TreeNode(nodeId, nodeLabel, parentNodeId, headId, childCopy);
    }

}


